#!/bin/bash

version="leer"
if [[ $1 == "version" ]]; then
   version=$2
fi
if [[ $version == "leer" ]]; then
    echo "Which version do you want to set?"
    version=$(python preparerelease.py)
fi

rm -r ./release/src
mkdir ./release/src

# Files
cp *.py ./release/src/
cp *.glade ./release/src/
cp eq_presets ./release/src/
cp -p pyjama.cfg ./release/src
cp pyjama.desktop ./release/src

# Folders
cp -pr plugins ./release/src
cp -pr clLayouts ./release/src
cp -pr locale ./release/src
cp -pr themes ./release/src
cp -pr images ./release/src
cp -pr extended_modules ./release/src
cp -pr modules ./release/src


echo "Creating package"
name="pyjama-"$version"_all"
name_gz=$name".tar.gz"
cp -r release $name              
tar -czf $name_gz $name                                

rm -r $name


if [[ $1 == "-i" ]]; then
   cd release
   sudo ./uninstall.sh
   sudo ./install.sh
fi


#gedit --new-window about.glade mkdeb.sh control
